Robberies HDU

来源:互联网 发布:深圳水务集团网络投诉 编辑:程序博客网 时间:2024/06/15 16:54

 Robberies

 HDU - 2955 

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university. 


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible. 


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj . 
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set. 

Notes and Constraints 
0 < T <= 100 
0.0 <= P <= 1.0 
0 < N <= 100 
0 < Mj <= 100 
0.0 <= Pj <= 1.0 
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
Sample Input
30.04 31 0.022 0.033 0.050.06 32 0.032 0.033 0.050.10 31 0.032 0.023 0.05
Sample Output
246

思路:

刚开始看这个题我的思路是错的,错误的把p当做包的最大值,然后pj[i]为物品,选取物品放入容量为j的背包,使其价值(mj[i]的和)最大;

但是这样想是不对的,小偷的目的是偷取尽可能多的钱,并且不被抓,因此应背包的限制条件sum应当为各个银行的总钱数,状态转移方程:

dp[j]=max(dp[j],dp[j-mj[i]]*(1-p[i])),其含义为:背包容量为j,我们选取逃跑概率较大的情况,我们可以理解为这是一个由所有钱数总和构成的背包,

包的财富就是概率(安全的概率)。我认为这个题的难以理解的地方在于,为什么要由被抓的概率转化为不被抓的概率,原因在于:只要抢一所

银行被抓,那么无论后面如何发展,其状态都应为被抓,被抓的概率乘被抓的概率也就没有了实际意义,而转化成不被抓的概率,则避免了这个问题。

#include<iostream>#include<cstdio>#include<algorithm>#include<cmath>#include<string.h>#define maxn 105using namespace std;int main(){int T,m,i,j;int mj[maxn];double pj[maxn],dp[10010],p;     //dp范围不能是maxn,因为sum的范围已经超出了105 cin>>T;while(T--){memset(dp,0,sizeof(dp));int sum=0;cin>>p>>m;for(i=1;i<=m;++i){cin>>mj[i]>>pj[i];sum+=mj[i];}dp[0]=1;         //背包问题必须要注意dp[0],需要根据不同情况定义其为1还是为0 //这里的dp[0],含义为偷得的钱为0时逃跑的概率,因此其为1 for(i=1;i<=m;++i){for(j=sum;j>=mj[i];--j){dp[j]=max(dp[j],dp[j-mj[i]]*(1-pj[i]));//dp[j]的含义为:偷取的钱为j时可以逃跑的概率 }}for(i=sum;i>=0;--i){     //小偷的目的是取得更多的钱,并且不被抓到,因此逆向循环一次,找到 if(dp[i]>(1-p)){     //第一个大于逃跑的最低概率的值,输出即可 cout<<i<<endl;break;}}}return 0;}



原创粉丝点击